<?php 
/*
Plugin Name: Theme Grabber
Plugin URI: http://www.avdude.com/themegrabber
Description: This wordpress plugin allows you to create and download a backup of a theme or your entire themes directory. Very useful to use just before updating a theme.
Version: 1.00
Author: David Fleming - Edge Technology Consulting
Author URI: http://www.avdude.com
*/
/*
Todo:
 
*/
//Define path variables
define("THMGBR_PLUGINPATH", "/" . plugin_basename(dirname(__file__)) . "/");
define("THMGBR_PLUGINFULLURL", WP_PLUGIN_URL . THMGBR_PLUGINPATH);
#WordPress Initialization
add_action('admin_menu', 'tmgbr_admin_menu');
#Add Menu Function
function tmgbr_admin_menu(){
    global $wpdb;
    $version = "ThemeGbr_1.0";
    $role = 'manage_options';
    #Create Admin Menus
    //add_menu_page($version, $version, $role, __file__, 'theme_grabber');
    add_submenu_page( 'themes.php', 'Theme Grabber', 'Theme Grabber', $role, __file__, 'theme_grabber');
    add_submenu_page( 'tools.php', 'Theme Grabber', 'Theme Grabber', $role, __file__, 'theme_grabber');
    
}
#set plugin global variables
global $thmgbr_dir;
$thmgbr_dir = WP_CONTENT_DIR."/uploads/themeBU";


function thmgbr_checkdir(){
    global $thmgbr_dir;
    if  (file_exists($thmgbr_dir)) {
        echo ('The backup directory, '.$thmgbr_dir.' is ok!.');
        if(!is_writable($thmgbr_dir)) {
			echo ('Backup directory is not writable.');

		}
    } else {
    if (wp_mkdir_p($thmgbr_dir)) {
        echo 'The backup direcotry, '.$thmgbr_dir.' has been created.';
        if(!is_writable($thmgbr_dir)) {
			echo ('Backup directory is not writable.');
            
		}
        }
    }
}

function theme_grabber(){
    global $thmgbr_dir;
?>
<div class="wrap">
<?php
$action = $_REQUEST['action'];
switch ($action){
    case 'backup_theme':
    ?>
    <img src="<?php echo THMGBR_PLUGINFULLURL ?>images/loading.gif" />
    <?php
    thmgbr_gettheme( $_POST["theme"]);
    break;
    case 'delete_bu':
    ?>
    <img src="<?php echo THMGBR_PLUGINFULLURL ?>images/loading.gif" />
    <?php
    thmgbr_deletebu( $_POST["theme"]);
    break;    
    default:
    thmgbr_checkdir();
    ?>
   <h2></h2><a href="http://www.avdude.com/themegrabber"><img src="<?php echo THMGBR_PLUGINFULLURL ?>images/themegrabber.png" alt=Theme Grabber for Wordpress" /></a></h2>

    <?
    ?>
    <p>This will create a backup of a single theme or all your themes.<br />
    Backups are stored at <?php echo $thmgbr_dir;?><br />
    You can create, download or delete a backup of one or all of your sites themes from this page.  <br />
    If a backup already exists of the theme selected, it will overwrite it.</p>
    
        <hr /><br /><form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
        <strong><label for="theme">Select theme to backup: </label></strong>
        <select name="theme" id="theme">
        <option value="ALL">All Themes</option>
    <?php
    foreach ( wp_get_themes( array( 'errors' => null ) ) as $a_stylesheet => $a_theme ) {
        	if ( $a_theme->errors() && 'theme_no_stylesheet' == $a_theme->errors()->get_error_code() )
        		continue;
            $selected = $a_stylesheet == $stylesheet ? ' selected="selected"' : '';
        	echo "\n\t" . '<option value="' . esc_attr( $a_stylesheet ) . '"' . $selected . '>' . $a_theme->display('Name') . '</option>';
        }
    ?>
        </select>
        <input type="submit" name="getthemes" value="Backup Theme(s)" onclick="alert('Be Patient, this might take a minute!')"/>   
        <input type="hidden" name="action" id="action" value="backup_theme"/>
        </form> 
        <br />
        <br />
    <?php 
    
    thmgbr_ListZips(array('index.php'));
    }
?>
</div>
<?php
}

function thmgbr_ListZips($exclude){
    global $thmgbr_dir;
    $ffs = scandir($thmgbr_dir); 
    echo "Current Backups Available:";
    echo '<ul class="ulli">'; 
    foreach($ffs as $ff){ 
        if(is_array($exclude) and !in_array($ff,$exclude)){ 
            if($ff != '.' && $ff != '..'){ 
            if(!is_dir($thmgbr_dir.'/'.$ff)){ 
            echo '<li><a href="'.WP_CONTENT_URL.'/uploads/themeBU/'.$ff.'"><button  style="background-color:#ccff99;width:250px" type="button"> Download Theme Backup( '.$ff.' ) </button></a>';
             } 
        } }
        } 
        
    echo '</ul>';
    echo "Remove Backup:";
    echo '<ul class="ulli">'; 
    foreach($ffs as $ff){ 
        if(is_array($exclude) and !in_array($ff,$exclude)){ 
            if($ff != '.' && $ff != '..'){ 
            if(!is_dir($thmgbr_dir.'/'.$ff)){ 
            echo '<li><form action="'.$_SERVER['REQUEST_URI'].'" method="post">';
            echo '<input type="hidden" name="action" id="action" value="delete_bu"/>';
            echo '<input type="hidden" name="theme" id="theme" value="'.$ff.'"/>';
            echo '<input style="background-color:pink;width:250px" type="submit" name="deletbu" value="  Delete Theme Backup ( '.$ff.' )  " onclick="return confirm(\'Deleting File '.$ff.'\')"/>';   
            echo '</form>';

            } 
        } }
    } 
        
    echo '</ul>';
    
    
     
} 

function thmgbr_deletebu($budelete){
    global $thmgbr_dir;
    if (unlink( $thmgbr_dir.'/'.$budelete)){
        $message = "File ".$budelete." has been removed!<br/>Returning to Theme Grabber Main Page . . . . ";
        thmgbr_showMessage($message, 'updated_below');
        echo '<META HTTP-EQUIV="refresh" CONTENT="3;URL='.$_SERVER['REQUEST_URI'].'">';
    }
}

function thmgbr_gettheme($theme){
        global $thmgbr_dir;
        //set folder location to zip
        if ($theme == 'ALL'){$wp_themes_dir = WP_CONTENT_DIR.'/themes';} 
        else {$wp_themes_dir = WP_CONTENT_DIR.'/themes/'.$theme;}
        //verify zip class in wordpress is available
        if(!class_exists('PclZip')){require_once(ABSPATH.'/wp-admin/includes/class-pclzip.php');}
        //add last slash to the backup directory
        $upload_dir = $thmgbr_dir."/";
        //create filename for the backup, must include directory path
        $filename = $upload_dir.$theme.'.zip';
        //instantiate a new zipclass with the defined filename
        $archive = new PclZip($filename);
        //create the zipfile
        if (!$archive->create($wp_themes_dir,PCLZIP_OPT_REMOVE_PATH,WP_CONTENT_DIR)) { echo "Backup Creation Failed!";}
        // Provide download link for new zip file
        $message = "File ".$theme." has been backed up!<br/>Returning to Theme Grabber Main Page . . . . ";
        thmgbr_showMessage($message, 'updated_below');
        echo '<META HTTP-EQUIV="refresh" CONTENT="3;URL='.$_SERVER['REQUEST_URI'].'">';
}

/**
 * Just show our message (with possible checking if we only want
 * to show message to certain users.
 */
function thmgbr_showMessage($message, $msg_type)
{
	switch ($msg_type){
	   case 'error':
       echo '<div id="message" class="error">';
       break;
       case 'updated':
        echo '<div id="message" class="updated">';
       break;
       case 'updated_fade':
       echo '<div id="message" class="updated fade">';
       break;
       case 'updated_below':
       echo '<div id="message" class="updated below-h2">';
       break; 
       case 'updated_highlight':
       echo '<div id="message" class="updated highlight">';
       break;
       default:
       echo '<div id="message" class="updated">';
       }
    echo "<p><strong>$message</strong></p></div>";
}    
function thmgbr_showAdminMessages()
{
    // Shows as an error message. You could add a link to the right page if you wanted.
    thmgbr_showMessage("You need to upgrade your database as soon as possible...", true);

    // Only show to admins
    if (user_can('manage_options')) {
       thmgbr_showMessage("Hello admins!");
    }
}


/** 
  * Call showAdminMessages() when showing other admin 
  * messages. The message only gets shown in the admin
  * area, but not on the frontend of your WordPress site. 
  */
//add_action('admin_notices', 'thmgbr_showAdminMessages');  
?>